///////////////////////////////////////////////////////////////
//                                                           //
// Binary to DB Converter                                    //
// Version 1.0                                               //
//                                                           //
// Copyright (c)2000-2001 TI-Calculator Programming Alliance //
// Written and Programmed by James Vernon <james@calc.org>   //
// ICQ#: 71589304                                            //
// http://tcpa.calc.org                                      //
//                                                           //
// You may use parts of this code as long as you give me     //
// credit.                                                   //
//                                                           //
///////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ERR_NONE 0
#define ERR_USAGE 1
#define ERR_FILE 2


int main(int argc, char *argv[])
{
	FILE *in, *out;
	char nameIn[13], nameOut[13];
	unsigned short lineCnt = 1;
	int byte = 0;

	if (argc != 2)
	{
		printf("USAGE: bintodb <binfile>      (no extension)\n");
		return ERR_USAGE;
	}

	strcpy(nameIn, argv[1]);
	strcat(nameIn, ".bin");
	strcpy(nameOut, argv[1]);
	strcat(nameOut, ".asm");

	if ((in=fopen(nameIn, "rb")) == NULL)
	{
		printf("Error opening %s!\n", nameIn);
		return ERR_FILE;
	}

	if ((out=fopen(nameOut, "w")) == NULL)
	{
		printf("Error creating %s!\n", nameOut);
		return ERR_FILE;
	}

	printf("Converting BIN to .DB ... ");

	fputs("; Converted with BINTODB, by James Vernon", out);

	while ((fread(&byte, 1, 1, in)) == 1)
	{
		if (--lineCnt == 0)
		{
			fputs("\n.db $", out);
			lineCnt = 20;
		}
		else
			fputs(",$", out);
		if (byte <= 15)
			fputs("0", out);
		fprintf(out, "%X", byte);
	}

	fputs("\n\n.end\n", out);

	printf("Done!\n");

	fclose(in);
	fclose(out);
	return ERR_NONE;
}
